******************************************************************
**								**
**		Ganma Reviced Tool (␳)			**
**								**
**						by ӂȂۂ	**
**								**
**					since Jan 26 1998	**
******************************************************************

	.include	DOSCALL.MAC
	.include	IOCSCALL.MAC
	.include	fefunc.h
	.include	CONST.H
	.include	RGB.mac


	.cpu	68000

	.offset	0

SSP_SAVE::	.ds.l	1
COLOR::		.ds.b	2
X0::		.ds.w	1
Y0::		.ds.w	1
W0::		.ds.w	1
H0::		.ds.w	1
Y_MIN::		.ds.w	1
Y_MAX::		.ds.w	1
NUMBER::	.ds.b	255
NUMBER_BUF::	.ds.b	4
NUMBER_TABLE::	.ds.b	64
NUMBER_TABLE_END::
WORK_SIZE::

	.text
	.even

	lea.l	WORK(pc),a6

	moveq.l	#0,d0
	move.w	d0,X0(a6)
	move.w	d0,Y0(a6)
	move.w	#512,W0(a6)
	move.w	#512,H0(a6)
	move.w	d0,Y_MIN(a6)
	move.w	#63,Y_MAX(a6)

**********************************************************
**		Comand Line Option Check		**
**********************************************************
C_CHECK::
	addq.l	#1,a2
	bsr	SKIPSP				*Xy[XXLbv
	tst.b	(a2)				*邩H
	beq	USAGE				*Ȃ USAGE
	lea.l	X0(a6),a3

OP_CHECK::
	bsr	SKIPSP				*Xy[XXLbv
	move.b	(a2),d0
	bsr	TOUPPER				*啶ɕϊĂ
	cmpi.b	#'R',d0
	beq	AFTER_RGB
	cmpi.b	#'G',d0
	beq	AFTER_RGB
	cmpi.b	#'B',d0
	beq	AFTER_RGB

NUM_GET::
	lea.l	NUMBER_BUF(a6),a0
	moveq.l	#0,d7

GET_NUMBER::
	tst.b	(a2)
	beq	GET_NUMBER_1
	cmpi.b	#SPACE,(a2)
	beq	GET_NUMBER_1
	cmpi.b	#TAB,(a2)			*space&tab͔΂
	beq	GET_NUMBER_1
	move.b	(a2)+,(a0)+			*ȏオ܂œ]JԂ
	addq.l	#1,d7				*JEg
	bra	GET_NUMBER

GET_NUMBER_1::
	lea.l	NUMBER_BUF(a6),a0
	bsr	GET_NUMBER1			*d2
	move.w	d2,(a3)+
	bra	OP_CHECK


AFTER_RGB::
	move.b	d0,COLOR(a6)
	addq.l	#1,a2
	lea.l	Y_MIN(a6),a3
	moveq.l	#2-1,d6

OP_CHECK_1::
	bsr	SKIPSP
	lea.l	NUMBER_BUF(a6),a0
	moveq.l	#0,d7

GET_Y_NUMBER::
	tst.b	(a2)
	beq	GET_Y_NUMBER_1
	cmpi.b	#SPACE,(a2)
	beq	GET_Y_NUMBER_1
	cmpi.b	#TAB,(a2)			*space&tab͔΂
	beq	GET_Y_NUMBER_1
	move.b	(a2)+,(a0)+			*ȏオ܂œ]JԂ
	addq.l	#1,d7				*JEg
	bra	GET_Y_NUMBER

GET_Y_NUMBER_1::
	move.l	d6,-(sp)
	lea.l	NUMBER_BUF(a6),a0
	bsr	GET_NUMBER1			*d2
	move.l	(sp)+,d6
	move.w	d2,(a3)+
	dbra	d6,OP_CHECK_1


GETARG::
	addq.l	#1,a2
	lea.l	NUMBER(a6),a0

GETARG0::
	tst.b	(a2)				*̏I[R[hH
	beq	GETARG1
	cmpi.b	#SPACE,(a2)
	beq	GETARG1
	cmpi.b	#TAB,(a2)			*space&tab͔΂
	beq	GETARG1
	move.b	(a2)+,(a0)+			*ȏオ܂œ]JԂ

	bra	GETARG0

GETARG1::
	clr.b	(a0)				*I[R[h

**********************************************************
**			Number Check			**
**********************************************************

	cmpi.w	#511,X0(a6)
	bhi	X0_OVER

	cmpi.w	#511,Y0(a6)
	bhi	Y0_OVER

	move.w	W0(a6),d0
	beq	W0_OVER
	cmpi.w	#512,d0
	bhi	W0_OVER

	move.w	H0(a6),d0
	beq	H0_OVER
	cmpi.w	#512,d0
	bhi	H0_OVER

	move.w	Y_MIN(a6),d0
	cmpi.w	#63,d0
	bhi	Y_MIN_OVER

	move.w	Y_MAX(a6),d1
	cmpi.w	#63,d1
	bhi	Y_MAX_OVER

	cmp.w	d1,d0
	bhi	Y_ERROR

**********************************************************
**			Make Table			**
**********************************************************

	lea.l	NUMBER(a6),a0
	FPACK	__STOD				*
	move.l	d0,a1
	move.l	d1,a2

	moveq.l	#0,d0
	move.w	Y_MAX(a6),d0
	move.w	Y_MIN(a6),d6
	sub.w	d6,d0

	FPACK	__LTOD				*fe1a	d0d0/d1
	move.l	d0,a4
	move.l	d1,a5

	lea.l	NUMBER_TABLE_END(a6),a0
						*a0,a1,a2,a4,a5,d6

	moveq.l	#63,d7
@@:
	move.l	d7,d0
	FPACK	__LTOD				*fe1a	d0d0/d1

	move.l	#$404f_8000,d2			*
	moveq.l	#0,d3				*double:1/64

	FPACK	__DDIV				*d0d1 /= d2d3

	move.l	a1,d2
	move.l	a2,d3

	FPACK	__POWER				*x^
						*d0/d1:js

	move.l	a4,d2
	move.l	a5,d3

	FPACK	__DMUL

	FPACK	__DTOL				*$fe1b
						*d0

	add.l	d6,d0				*Y_MIN
	move.b	d0,-(a0)

	dbra	d7,@B

**********************************************************
**			␳				**
**********************************************************

	moveq.l	#0,d5
	move.w	X0(a6),d6
	move.w	Y0(a6),d7
	move.w	d7,d5

	mulu.w	d6,d7
	lea.l	NUMBER_TABLE(a6),a0

	add.l	d6,d6
	lsl.l	#8,d5
	lsl.l	#2,d5				*x1024
	add.l	d6,d5
	lea.l	$00C0_0000,a1
	add.l	d5,a1

	moveq.l	#0,d7
	move.w	H0(a6),d6
	subq.w	#1,d6
	move.w	W0(a6),d7

	move.l	#512,d5
	sub.w	d7,d5
	add.w	d5,d5
	subq.w	#1,d7				*dbra
	moveq.l	#0,d1
	move.w	d7,d4

		clr.l	-(sp)
		DOS	_SUPER			* X[p[oCU[h
		move.l	d0,SSP_SAVE(a6)		* sspҔ
		addq.l	#4,sp

	move.b	COLOR(a6),d0
	cmp.b	#'R',d0
	beq	R_W_LOOP
	cmp.b	#'G',d0
	beq	G_W_LOOP
	cmp.b	#'B',d0
	beq	B_W_LOOP
	bra	RGB_ERROR

B_H_LOOP::
	adda.l	d5,a1
	move.w	d4,d7

B_W_LOOP::
	move.w	(a1),d0
	DERGB	d0,d1,d2,d3			*COL,_B,_R,_G

	move.b	(d1.w,a0),d1

	RGB	d1,d2,d3,d0			*B,R,G,COL
	move.w	d0,(a1)+

	dbra	d7,B_W_LOOP

	dbra	d6,B_H_LOOP
	bra	GANMA_END


R_H_LOOP::
	add.l	d5,a1
	move.w	d4,d7

R_W_LOOP::
	move.w	(a1),d0
	DERGB	d0,d1,d2,d3			*COL,_B,_R,_G

	move.b	(d2.w,a0),d2

	RGB	d1,d2,d3,d0			*B,R,G,COL
	move.w	d0,(a1)+
	dbra	d7,R_W_LOOP

	dbra	d6,R_H_LOOP
	bra	GANMA_END


G_H_LOOP::
	add.l	d5,a1
	move.w	d4,d7

G_W_LOOP::
	move.w	(a1),d0
	DERGB	d0,d1,d2,d3			*COL,_B,_R,_G

	move.b	(d3.w,a0),d3

	RGB	d1,d2,d3,d0			*B,R,G,COL
	move.w	d0,(a1)+
	dbra	d7,G_W_LOOP

	dbra	d6,G_H_LOOP
*	bra	GANMA_END

GANMA_END::
		move.l	SSP_SAVE(a6),-(sp)	*
		DOS	_SUPER			* [U[[h
		addq.l	#4,sp			*

END::
	DOS	_EXIT

**********************************************************
**			Error				**
**********************************************************

USAGE::
	pea.l	USAGE_MES(pc)
	bra	DISP_ABORT

IN_NUMBER_ERR::
	pea.l	IN_NUMBER_ERR_MES(pc)
	bra	DISP_ABORT

RGB_ERROR::
	pea.l	RGB_ERROR_MES(pc)
	bra	DISP_ABORT

X0_OVER::
	pea.l	X0_OVER_MES(pc)
	bra	DISP_ABORT

Y0_OVER::
	pea.l	Y0_OVER_MES(pc)
	bra	DISP_ABORT

W0_OVER::
	pea.l	W0_OVER_MES(pc)
	bra	DISP_ABORT

H0_OVER::
	pea.l	H0_OVER_MES(pc)
	bra	DISP_ABORT

Y_MIN_OVER::
	pea.l	Y_MIN_OVER_MES(pc)
	bra	DISP_ABORT

Y_MAX_OVER::
	pea.l	Y_MAX_OVER_MES(pc)
	bra	DISP_ABORT

Y_ERROR::
	pea.l	Y_ERROR_MES(pc)
*	bra	DISP_ABORT

DISP_ABORT::
	DOS	_PRINT
	addq.l	#4,sp
	bra	END

**********************************************************
**			SUB ROUTINE			**
**********************************************************

GET_NUMBER1::
	moveq.l	#0,d0
	moveq.l	#0,d2
	move.l	d7,d5
	subq.l	#1,d5

	subq.l	#2,d7		*dbrap-2
	move.l	d7,d6
1:
	move.l	d6,d7
	move.b	(a0)+,d0
	cmpi.b	#'0',d0			*0`9ȊO͒e
	bcs	IN_NUMBER_ERR		*
	cmpi.b	#'9'+1,d0		*
	bcc	IN_NUMBER_ERR		*
	subi.b	#$30,d0			*𐔎ɂ

	cmpi.l	#-1,d7
	ble	GET_NUMBER3
2:
	move.l	d0,d1			*d0=d1
	add.l	d1,d1			*d1=x2
	lsl.l	#3,d0			*d0=x8
	add.l	d1,d0			*d0=x10
	dbra	d7,2B

GET_NUMBER3::
	add.l	d0,d2
	moveq.l	#0,d0
	subq.l	#1,d6
	dbra	d5,1B
	rts


SKIPSP0::	addq.l	#1,a2
SKIPSP::
		cmpi.b	#SPACE,(a2)		*
		beq	SKIPSP0
		cmpi.b	#TAB,(a2)		*space&tab͔΂
		beq	SKIPSP0
		rts

TOUPPER::
		cmpi.b	#"a",d0			*Ȃ啶
		bcs	TOUPPER0
		cmpi.b	#"z"+1,d0
		bcc	TOUPPER0
		subi.b	#$20,d0
TOUPPER0::
		rts

**********************************************************
**			Data				**
**********************************************************

	.data
	.even

USAGE_MES::	.dc.b	'Ganma Reviced Tool ver0.1',CR,LF
		.dc.b	'	 Programed by ӂȂۂ Mar 20 1998',CR,LF
		.dc.b	CR,LF
		.dc.b	'usage : gh.r x0 y0 w0 h0 Color Min Max ',CR,LF
		.dc.b	'      : color = R,G,B',CR,LF,0
		.dc.b	'      : 0 [x0,y0] 511',CR,LF
		.dc.b	'      : 1 [h0,w0] 512',CR,LF
		.dc.b	'      : 0 [Min,Max] 63',CR,LF

IN_NUMBER_ERR_MES::	.dc.b	'Option Number Error!',CR,LF,0
RGB_ERROR_MES::		.dc.b	'not R,G,B',CR,LF,0
X0_OVER_MES::		.dc.b	'0  x0  511',CR,LF,0
Y0_OVER_MES::		.dc.b	'0  y0  511',CR,LF,0
W0_OVER_MES::		.dc.b	'1  w0  512',CR,LF,0
H0_OVER_MES::		.dc.b	'1  h0  512',CR,LF,0
Y_MIN_OVER_MES::	.dc.b	'0  Min  63',CR,LF,0
Y_MAX_OVER_MES::	.dc.b	'0  Max  63',CR,LF,0
Y_ERROR_MES::		.dc.b	'Min  Max',CR,LF,0

**********************************************************
**			bss				**
**********************************************************

	.bss
	.even

WORK::
	.ds.b	WORK_SIZE

	.stack
	.even

MYSTACK::
	.ds.l	256		*X^bN̈
MYSP::

	.end
